import { ConfigureClient } from "../configure";
import { assertFetch } from "./utils";
jest.mock("node-fetch", () => ({
    default: jest.fn().mockReturnValue(Promise.resolve({
        status: 200,
        json: jest.fn().mockReturnValue(Promise.resolve({}))
    }))
}));
const endpoints = {
    save: { method: "PUT", path: "/save" }
};
const session = {
    id: "1",
    data: []
};
const client = () => new ConfigureClient("host", "token", endpoints);
describe("configure", () => {
    describe("load", () => {
        assertFetch(client(), c => c.load("itemId", true), `host/configure/load.json`, {
            itemId: "itemId",
            addPreview: true
        });
    });
    describe("save", () => {
        assertFetch(client(), c => c.save("itemId", [], []), `host${endpoints.save.path}`, 
        // tslint:disable-next-line:object-literal-shorthand
        { itemId: "itemId", models: [], buildInfo: [] }, "PUT");
    });
});
//# sourceMappingURL=configure.test.js.map