var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsonHeaders } from "../types";
import fetch from "node-fetch";
jest.mock("node-fetch", () => ({
    default: jest.fn().mockReturnValue(Promise.resolve({
        status: 200,
        json: jest.fn().mockReturnValue(Promise.resolve({}))
    }))
}));
export const assertFetch = (client, withClient, path, body, method = "POST") => {
    const bodyString = JSON.stringify(body);
    it(`calls fetch with: ${path} and ${bodyString}`, () => __awaiter(this, void 0, void 0, function* () {
        fetch.mockClear();
        yield withClient(client);
        expect(fetch).toHaveBeenCalledWith(`${path}?token=token`, {
            method,
            headers: jsonHeaders(),
            body: bodyString
        });
    }));
};
//# sourceMappingURL=utils.js.map