var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import fetch from "node-fetch";
import { jsonHeaders } from "./types";
export class BaseClient {
    constructor(host, token) {
        this.host = host;
        this.token = token;
    }
    call(endpoint, data) {
        return fetch(`${this.host}${endpoint.path}?token=${this.token}`, {
            method: endpoint.method.toUpperCase(),
            headers: Object.assign({}, jsonHeaders()),
            body: JSON.stringify(data)
        }).then((r) => __awaiter(this, void 0, void 0, function* () {
            const data = yield r.json();
            if (r.status !== 200) {
                throw new Error(`call to ${endpoint.path} failed. ${data.error}`);
            }
            return data;
        }));
    }
}
//# sourceMappingURL=base.js.map