import { BaseClient } from "./base";
import * as debug from "debug";
const loadPath = "/configure/load.json";
const log = debug("kds:pie-api-player:configure-client");
export class ConfigureClient extends BaseClient {
    constructor(host, token, endpoints) {
        super(host, token);
        this.host = host;
        this.token = token;
        this.endpoints = endpoints;
    }
    load(itemId, addPreview) {
        log("[load] itemId", itemId);
        return this.call({ path: loadPath, method: "post" }, { itemId, addPreview });
    }
    save(itemId, models, buildInfo) {
        log("[save] itemId", itemId, models);
        return this.call(this.endpoints.save, {
            itemId,
            models,
            buildInfo
        });
    }
}
//# sourceMappingURL=configure.js.map