import { BaseClient } from "./base";
export class PlayerApiClient extends BaseClient {
    constructor(host, token, endpoints) {
        super(host, token);
        this.host = host;
        this.token = token;
        this.endpoints = endpoints;
    }
    load(itemId, sessionId) {
        return this.call({ method: "POST", path: "/player/load.json" }, { itemId, sessionId });
    }
    saveSession(session) {
        return this.call(this.endpoints.saveSession, session);
    }
    model(itemId, session, env) {
        return this.call(this.endpoints.model, {
            itemId,
            session,
            env
        });
    }
    score(itemId, session, disablePartialScoring = false) {
        return this.call(this.endpoints.score, {
            itemId,
            session,
            disablePartialScoring
        });
    }
}
//# sourceMappingURL=player.js.map