import { times } from "lodash";
import * as debug from "debug";
const log = debug("pie-api:helpers:promise");
const delay = (p, delay) => {
    log("[delay], delay: ", delay);
    if (delay <= 0) {
        log("return immediate promise");
        return p();
    }
    log("return delayed call...");
    return new Promise((resolve, reject) => {
        setTimeout(() => {
            p()
                .then(o => resolve(o))
                .catch(e => reject(e));
        }, delay);
    });
};
export const gapError = (gap) => new Error(`gap must be greater than 0 and less than ${MAX_GAP}`);
export const repeatError = (repeat) => new Error(`invalid repeat count: ${repeat}`);
const MAX = 1000;
const MAX_GAP = 1000;
/**
 * TODO: there appears to be some slowness here.
 * Need to find out if below is the cause of it.
 * @param fn
 * @param repeat
 * @param gap
 */
export const callPromise = (fn, repeat, gap) => {
    if (repeat <= 0 || repeat > MAX) {
        return Promise.reject(repeatError(repeat));
    }
    if (gap <= 0 || gap > MAX_GAP) {
        return Promise.reject(gapError(gap));
    }
    log("call promise...");
    const arr = times(repeat - 1, () => () => delay(fn, gap));
    log("arr: ", arr);
    let pp = fn();
    // tslint:disable-next-line:no-increment-decrement
    for (let i = 0, len = arr.length; i < len; i++) {
        // res += testData[i];
        pp = pp.catch(e => {
            return arr[i]();
        });
    }
    log("execute reduced promise...");
    return pp;
};
//# sourceMappingURL=promise.js.map